
from django.http import JsonResponse
from django.http import HttpResponse
import requests
from hashlib import sha1
import json
import base64
from Crypto import Random
from Crypto.Cipher import AES
from view import views
from django.http import HttpResponseRedirect

def cashierOrderStr(request):
    
    request.encoding='utf-8'

    
    dic = {}
    
    dic.setdefault("merchantId", request.POST['merchantId'])
    
    dic.setdefault("requestId", request.POST['requestId'])
    dic.setdefault("orderAmount", request.POST['orderAmount'])
    
    dic.setdefault("orderCurrency", request.POST['orderCurrency'])
    dic.setdefault("language", request.POST['language'])
    dic.setdefault("notifyUrl", request.POST['notifyUrl'])
    dic.setdefault("callbackUrl", request.POST['callbackUrl'])
    dic.setdefault("terminalNo", request.POST['terminalNo'])
    dic.setdefault("remark", request.POST['remark'])

    
    #dic.setdefault("orderType", request.POST['orderType'])
    
    orderType = request.POST['orderType'] 

    if  orderType != None :
        
        if orderType == "RISK_SHIP" :
            
            RISK_SHIP = {}
            
            RISK_SHIP.setdefault("shipCountry", request.POST['shipCountry'])
            RISK_SHIP.setdefault("shipState", request.POST['shipState'])
            RISK_SHIP.setdefault("shipStreet", request.POST['shipStreet'])
            RISK_SHIP.setdefault("shipPost", request.POST['shipPost'])
            RISK_SHIP.setdefault("shipPhone", request.POST['shipPhone'])
            RISK_SHIP.setdefault("shipEmail", request.POST['shipEmail'])        
            
            dic.setdefault("shipInfo",RISK_SHIP)
            
        elif orderType == "RISK_BILL" :
            
            RISK_BILL = {}
            
            RISK_BILL.setdefault("billCountry", request.POST['billCountry'])
            RISK_BILL.setdefault("billState", request.POST['billState'])
            RISK_BILL.setdefault("billCity", request.POST['billCity'])
            RISK_BILL.setdefault("billStreet", request.POST['billStreet'])
            RISK_BILL.setdefault("billPhone", request.POST['billPhone'])
            RISK_BILL.setdefault("billEmail", request.POST['billEmail'])
            
            dic.setdefault("billInfo",RISK_BILL)
            
        elif orderType == "RISK_SHIP_BILL" :
            
            RISK_SHIP = {}
            
            RISK_SHIP.setdefault("shipCountry", request.POST['shipCountry'])
            RISK_SHIP.setdefault("shipState", request.POST['shipState'])
            RISK_SHIP.setdefault("shipStreet", request.POST['shipStreet'])
            RISK_SHIP.setdefault("shipPost", request.POST['shipPost'])
            RISK_SHIP.setdefault("shipPhone", request.POST['shipPhone'])
            RISK_SHIP.setdefault("shipEmail", request.POST['shipEmail'])    
            
            RISK_BILL = {}
            
            RISK_BILL.setdefault("billCountry", request.POST['billCountry'])
            RISK_BILL.setdefault("billState", request.POST['billState'])
            RISK_BILL.setdefault("billCity", request.POST['billCity'])
            RISK_BILL.setdefault("billStreet", request.POST['billStreet'])
            RISK_BILL.setdefault("billPhone", request.POST['billPhone'])
            RISK_BILL.setdefault("billEmail", request.POST['billEmail'])
            
            dic.setdefault("shipInfo",RISK_SHIP)
            dic.setdefault("billInfo",RISK_BILL)    
    
    dicstr = views.get_sort(dic)
    
    
    psw=sha1()
    
    print(dicstr)
    psw.update(dicstr.encode('utf8'))
    
    #spwdSha2 = psw.hexdigest();
    spwdSha1=psw.digest()
    print('spwdSha1:-------',spwdSha1)
    
    HMAC0 = views.gen_sign(spwdSha1)
    
    dic.setdefault("hmac", HMAC0.decode())
    
    
    #dichmac = dict(sorted(dic.items(),reverse=False))
    
    dicjson = dict(sorted(dic.items(),reverse=False))
    
    print(dicjson)
    
    random = views.gen_random()
    
    print('random-------',random.encode())
    
    encrypted_text = views.aes_cipher(random,json.dumps(dicjson))
    
    print (len(encrypted_text),encrypted_text)
    
    aesRsa = views.gen_encrypt(random)
    
    
    print('aesrsa:-----------------------------',aesRsa)
    
    str = aesRsa.decode()
    
    print(str)
    #aesRsastr = str(base64.urlsafe_b64encode(aesRsa),'utf8')
    
    url='https://apis.5upay.com/icc/order'
    headers1 = {'Content-Type': "application/vnd.5upay-v3.0+json",'encryptKey':str,'merchantId':request.POST['merchantId'],'requestId': request.POST['requestId']}
    
    response = requests.post(url, data = encrypted_text, headers = headers1)
    
    
    head = response.headers
    print(head)
    
    x = requests.structures.CaseInsensitiveDict(head)
    js = dict(x)
    
    #print(js)
    
    encryptKey = js.get("encryptKey")
    
    encryptKey = views.gen_decrypt(encryptKey)
    
    print('encryptKey',encryptKey)
    
    
    result = response.text

    print(result)
    json56 = json.loads(result)
    
    encryptKeyjson = json56['data']
   
    print('encryptKeyjson',encryptKeyjson)

    aes_de = AES.new(encryptKey, AES.MODE_ECB) 
    
    decrypted_text = (aes_de.decrypt(base64.decodebytes(bytes(encryptKeyjson, encoding='utf8'))).rstrip(b'\0')).decode()
    decrypted_text = decrypted_text[:-ord(decrypted_text[-1])]
    
    print (decrypted_text)
    decryptdic = eval(decrypted_text)
    #建议获取提交金额进行验签,或与返回金额进行对比,防止提交过程中金额被篡改
    status = decryptdic.get("status")
    hmac = decryptdic.get("hmac")
    
    
    
    decryptdicjson = dict(sorted(decryptdic.items(),reverse=False))
 
    if hmac != None:
        
          
        hamcstr = decryptdicjson.pop("hmac")
        
        print ('hamcstr',hamcstr)
        decryptdicj = views.get_sort(decryptdicjson)
        print(decryptdicj)      
        shade=sha1()
    
        shade.update(decryptdicj.encode('utf8'))
    
        destrSha1=shade.digest()
        
        strsss = views.verify_sign(destrSha1,hamcstr)
        
        print ('strsss',strsss)
        print ('status',status)
        if strsss == True :
            
            if status == "SUCCESS":
                
                redirectUrl = decryptdic.get("redirectUrl")
                
                if  redirectUrl != None :
                    return HttpResponseRedirect(redirectUrl)
                
                else :
                    return HttpResponse(decrypted_text)
            
        else :
            
            print (decrypted_text)
                    
            return JsonResponse({'cer verify_sign fail:':decrypted_text})
    else :
        return HttpResponse(decrypted_text)
    